package sortedlist;
import java.util.*;
//   Generando listas ordenadas y otros. Author Tymos
public class SortedList extends LinkedList{ 
    ArrayItems arrayItems;
    SortedList list01;
    SortedList list02;

    public SortedList(){                    //  Primer constructor
        super();                            //  Genera una lista vaca 
    }

    public SortedList(ArrayItems array){    //  Segundo constructor
        super(array);                       //  Generamos coleccion SortedList 
    }                                       //  usando coleccin ArrayItems
        
    public void demo01(){  // Genera lista con secuencia idem a arrayItems
        System.out.println("Demo01 - genero list01 a partir de arrayItems");
        arrayItems = new ArrayItems(8,'R');//  arrayItems con 8 items random
        System.out.println("objeto arrayItems contiene");
        System.out.println(arrayItems);
        list01 = new SortedList(arrayItems);
        System.out.println("lista list01 contiene");
        System.out.println(list01);         //  list01 con 8 items idem 
    }
    
    public void demo02(){   //  Genera list02 invirtiendo list01
        System.out.println("Demo02 -  genera list02 como list01 invertida");
        list02 = new SortedList(); //   lista vaca
        Iterator list01It = list01.iterator();  //  lista creada en demo01
        while (list01It.hasNext()){   //  mientras tengamos en list01
            list02.addFirst(list01It.next());
        }
        System.out.println("lista list02  contiene");
        System.out.println(list02);         
    }
    
    public void demo03(){   //  Verifica existen elementos en ambas listas
        System.out.println("Demo03 - Verifica si todas de list01 existen en list02");
        Iterator list01It = list01.iterator();  //  lista creada en demo01
        boolean todos = true;
        while (list01It.hasNext())   //  mientras tengamos en list01
            if (!list02.contains(list01It.next()))
                todos = false;
        if(todos)
            System.out.println("list02  contiene todos de list01");
        else
            System.out.println("list02  no contiene todos de list01");         
    }
    
    public void demo04(){   //  Remuevo ultimo de list02, luego idem demo03
        System.out.println("Demo04 - remuevo ultimo de list02, luego idem demo03");
        Iterator list01It = list01.iterator();  //  lista creada en demo01
        boolean todos = true;
        list02.removeLast();
        while (list01It.hasNext())   //  mientras tengamos en list01
            if (!list02.contains(list01It.next()))
                todos = false;
        if(todos)
            System.out.println("list02  contiene todos de list01");
        else
            System.out.println("list02  no contiene todos de list01");         
    } 
    
     public void demo05(){   //  Genera list02 ordenada desde list01
        System.out.println("Demo05 - genero list02 ordenada desde list01");
        list02 = new SortedList(); //   list02 vaca
        Item item01;    // para items de list01
        Item item02;    // para items de list02
        boolean inserto;    //  Un flag para verificar inserciones intermedias

        Iterator list01It = list01.iterator();  //  Un iterador para list01
        while (list01It.hasNext()){   //  recorriendo list01
            inserto = false;    //  A priori, suponemos que no las hay
            item01 = (Item)(list01It.next());   // item de list01
            
            ListIterator list02It = list02.listIterator();//  Otro para list02
            while (list02It.hasNext()){   //  recorriendo list02
                item02 = (Item)(list02It.next()); // item de list02  
                if(item02.esMayor(item01)){
                    System.out.println("Insercion intermedia "+item01.getCodigo());
                    list02It.previous();  //  Retrocedo al anterior
                    list02It.add(item01);   //  inserto un intermedio
                    System.out.println(list02);
                    inserto = true;
                    break;
                }
            }   //  while (list02It.hasNext())
            if(!inserto){ // insercion en los extremos de la lista
                System.out.println("Insercion en extremos "+item01.getCodigo());
                list02It.add(item01);   //  luego inserto
                System.out.println(list02);
            }
        }   //  while (list01It.hasNext())
        System.out.println("lista list02  contiene");
        System.out.println(list02);         

    }   

     public static void main(String[] args){
       SortedList list = new SortedList();
       list.demo01();
       list.demo02();
       list.demo03();
       list.demo04();
       list.demo05();
   }
}
